.section .text
.arm

.global getSystemTick
.type getSystemTick, %function
getSystemTick:
	svc 0x28
	bx lr

.global backdoor
.type backdoor, %function
backdoor:
	svc 0x7B
	bx lr

.global FlushProcessDataCache
.type FlushProcessDataCache, %function
FlushProcessDataCache:
	svc 0x54
	bx lr

.global disable_IRQ
.type disable_IRQ, %function
disable_IRQ:
	mrs r0, cpsr
	orr r0, r0, #0x80  @IRQ
	msr cpsr_c, r0
	bx lr
	
.global enable_IRQ
.type enable_IRQ, %function
enable_IRQ:
	mrs r0, cpsr
	bic r0, r0, #0x80  @IRQ
	msr cpsr_c, r0
	bx lr
	
.global disable_FIQ
.type disable_FIQ, %function
disable_FIQ:
	mrs r0, cpsr
	orr r0, r0, #0x40  @FIQ
	msr cpsr_c, r0
	bx lr
	
.global enable_FIQ
.type enable_FIQ, %function
enable_FIQ:
	mrs r0, cpsr
	bic r0, r0, #0x40  @FIQ
	msr cpsr_c, r0
	bx lr

.global disable_MPU
.type disable_MPU, %function
disable_MPU:
	mrc p15, 0, r0, c1, c0, 0
	bic r0, r0, #1
	mcr p15, 0, r0, c1, c0, 0
	bx lr
	
.global enable_MPU
.type enable_MPU, %function
enable_MPU:
	mrc p15, 0, r0, c1, c0, 0
	orr r0, r0, #1
	mcr p15, 0, r0, c1, c0, 0
	bx lr
